diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/int64x64-test-suite.cc ns-3.36/src/core/test/int64x64-test-suite.cc
--- ns-3.35/src/core/test/int64x64-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/int64x64-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -1297,7 +1619,9 @@
     AddTestCase (new Int64x64InvertTestCase (), TestCase::QUICK);
     AddTestCase (new Int64x64DoubleTestCase (), TestCase::QUICK);
   }
-}  g_int64x64TestSuite;
+};
+
+static Int64x64TestSuite g_int64x64TestSuite; //!< Static variable for test initialization
 
 }  // namespace test
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/length-test-suite.cc ns-3.36/src/core/test/length-test-suite.cc
--- ns-3.35/src/core/test/length-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/length-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -43,14 +43,12 @@
 
 /**
  * \file
- * \ingroup core-tests
- * \ingroup length
  * \ingroup length-tests
- * Length class test suite.
+ * Length class tests.
  */
 
 /**
- * \ingroup core-tests
+ * \ingroup core-tests length
  * \defgroup length-tests Length test suite
  */
 
@@ -139,13 +137,20 @@
 
   /**
    * Test that a length object can be constructed from a string
-   * @{
+   * \param unitValue  //!< Value to test.
+   * \param meterValue //!< Reference value [m].
+   * \param tolerance  //!< Tolerance.
+   * \param symbols    //!< Unit symbols.
    */
   void TestConstructLengthFromString (double unitValue,
                                       double meterValue,
                                       double tolerance,
                                       const std::initializer_list<std::string>& symbols);
 
+  /**
+   * Test that a length object can be constructed from a string
+   * @{
+   */
   void TestConstructLengthFromMeterString ();
   void TestConstructLengthFromNanoMeterString ();
   void TestConstructLengthFromMicroMeterString ();
@@ -1491,10 +1496,14 @@
   {}
 
 private:
-    //class with Length attribute
+    /// Class with Length attribute
     class TestObject : public Object
     {
     public:
+        /**
+         * \brief Get the type ID.
+         * \return The object TypeId.
+         */
         static TypeId GetTypeId ();
 
         TestObject ()
@@ -1505,7 +1514,7 @@
         {}
 
     private:
-        Length m_length;
+        Length m_length; //!< Length object
     };
 
 private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/pair-value-test-suite.cc ns-3.36/src/core/test/pair-value-test-suite.cc
--- ns-3.35/src/core/test/pair-value-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/pair-value-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -38,20 +38,40 @@
 
 NS_LOG_COMPONENT_DEFINE ("PairTestSuite");
 
+/**
+ * \file
+ * \ingroup pair-tests
+ * Pairs tests.
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup pair-tests Pairs tests
+ */
+
+/**
+ * \ingroup pair-tests
+ * 
+ * Object holding pairs of values.
+ */
 class PairObject : public Object
 {
 public:
   PairObject ();
   virtual ~PairObject ();
 
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
   static
   TypeId GetTypeId ();
 
   friend std::ostream &operator <<(std::ostream &os, const PairObject &obj);
 
 private:
-  std::pair <std::string, std::string> m_stringPair;
-  std::pair <double, int> m_doubleIntPair;
+  std::pair <std::string, std::string> m_stringPair;  //!< A string pair.
+  std::pair <double, int> m_doubleIntPair;             //!< A pair of double, int.
 };
 
 PairObject::PairObject ()
@@ -84,6 +104,13 @@
   return tid;
 }
 
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] obj The PairObject.
+ * \returns The reference to the output stream.
+ */
 std::ostream &
 operator << (std::ostream &os, const PairObject &obj)
 {
@@ -92,7 +119,11 @@
   return os;
 }
 
-/* Test instantiation, initialization, access */
+/**
+ * \ingroup pair-tests
+ * 
+ * Pair test - Test instantiation, initialization, access.
+ */
 class PairValueTestCase : public TestCase
 {
 public:
@@ -132,6 +163,11 @@
 
 }
 
+/**
+ * \ingroup pair-tests
+ * 
+ * Pair test - test setting through attribute interface.
+ */
 class PairValueSettingsTestCase : public TestCase
 {
 public:
@@ -160,6 +196,11 @@
   NS_TEST_ASSERT_MSG_EQ ((oss.str ()), (ref.str ()), "Pairs not correctly set");
 }
 
+/**
+ * \ingroup pair-tests
+ *  
+ * \brief The pair-value Test Suite.
+ */
 class PairValueTestSuite : public TestSuite
 {
   public:
@@ -173,4 +214,4 @@
   AddTestCase (new PairValueSettingsTestCase (), TestCase::QUICK);
 }
 
-static PairValueTestSuite pairValueTestSuite; //!< Static variable for test initialization
+static PairValueTestSuite g_pairValueTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/random-variable-stream-test-suite.cc ns-3.36/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.35/src/core/test/random-variable-stream-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/random-variable-stream-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -49,6 +49,13 @@
 namespace RandomVariable {
 
 /**
+ * \file
+ * \ingroup rng-tests
+ * Random number generator streams tests.
+ */
+
+/**
+ * \ingroup rng-tests
  * Base class for RandomVariableStream test suites.
  */
 class TestCaseBase : public TestCase
@@ -301,7 +308,7 @@
    * deterministic value of seed=3 and default run number=1 every time:
    *   NS_GLOBAL_VALUE="RngSeed=3" ./test.py -s random-variable-stream-generators
    * or equivalently (to see log output):
-   *   NS_LOG="RandomVariableStreamGenerators" NS_GLOBAL_VALUE="RngSeed=3" ./waf --run "test-runner --suite=random-variable-stream-generators"
+   *   NS_LOG="RandomVariableStreamGenerators" NS_GLOBAL_VALUE="RngSeed=3" ./ns3 run "test-runner --suite=random-variable-stream-generators"
    *
    * Conversely, this command will cause this test suite to use a seed
    * based on time-of-day, and run number=0: 
@@ -339,6 +346,7 @@
 
 
 /**
+ * \ingroup rng-tests
  * Test case for uniform distribution random variable stream generator.
  */
 class UniformTestCase : public TestCaseBase
@@ -460,6 +468,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic uniform distribution random variable stream generator
  */
 class UniformAntitheticTestCase : public TestCaseBase
@@ -535,6 +544,7 @@
 
 }
 /**
+ * \ingroup rng-tests
  * Test case for constant random variable stream generator
  */
 class ConstantTestCase : public TestCaseBase
@@ -581,6 +591,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for sequential random variable stream generator
  */
 class SequentialTestCase : public TestCaseBase
@@ -637,6 +648,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for normal distribution random variable stream generator
  */
 class NormalTestCase : public TestCaseBase
@@ -718,6 +730,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic normal distribution random variable stream generator
  */
 class NormalAntitheticTestCase : public TestCaseBase
@@ -801,6 +814,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for exponential distribution random variable stream generator
  */
 class ExponentialTestCase : public TestCaseBase
@@ -877,6 +891,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic exponential distribution random variable stream generator
  */
 class ExponentialAntitheticTestCase : public TestCaseBase
@@ -956,6 +971,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for Pareto distribution random variable stream generator
  */
 class ParetoTestCase : public TestCaseBase
@@ -1043,6 +1059,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic Pareto distribution random variable stream generator
  */
 class ParetoAntitheticTestCase : public TestCaseBase
@@ -1134,6 +1151,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for Weibull distribution random variable stream generator
  */
 class WeibullTestCase : public TestCaseBase
@@ -1238,6 +1256,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic Weibull distribution random variable stream generator
  */
 class WeibullAntitheticTestCase : public TestCaseBase
@@ -1344,6 +1363,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for log-normal distribution random variable stream generator
  */
 class LogNormalTestCase : public TestCaseBase
@@ -1440,6 +1460,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic log-normal distribution random variable stream generator
  */
 class LogNormalAntitheticTestCase : public TestCaseBase
@@ -1538,6 +1559,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for gamma distribution random variable stream generator
  */
 class GammaTestCase : public TestCaseBase
@@ -1624,6 +1646,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic gamma distribution random variable stream generator
  */
 class GammaAntitheticTestCase : public TestCaseBase
@@ -1714,6 +1737,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for Erlang distribution random variable stream generator
  */
 class ErlangTestCase : public TestCaseBase
@@ -1803,6 +1827,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic Erlang distribution random variable stream generator
  */
 class ErlangAntitheticTestCase : public TestCaseBase
@@ -1896,6 +1921,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for Zipf distribution random variable stream generator
  */
 class ZipfTestCase : public TestCaseBase
@@ -1971,6 +1997,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic Zipf distribution random variable stream generator
  */
 class ZipfAntitheticTestCase : public TestCaseBase
@@ -2049,6 +2076,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for Zeta distribution random variable stream generator
  */
 class ZetaTestCase : public TestCaseBase
@@ -2108,6 +2136,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic Zeta distribution random variable stream generator
  */
 class ZetaAntitheticTestCase : public TestCaseBase
@@ -2170,6 +2199,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for deterministic random variable stream generator
  */
 class DeterministicTestCase : public TestCaseBase
@@ -2243,6 +2273,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for empirical distribution random variable stream generator
  */
 class EmpiricalTestCase : public TestCaseBase
@@ -2335,6 +2366,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for antithetic empirical distribution random variable stream generator
  */
 class EmpiricalAntitheticTestCase : public TestCaseBase
@@ -2405,6 +2437,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * Test case for caching of Normal RV parameters (see issue #302)
  */
 class NormalCachingTestCase : public TestCaseBase
@@ -2437,6 +2470,7 @@
 }
 
 /**
+ * \ingroup rng-tests
  * RandomVariableStream test suite, covering all random number variable
  * stream generator types.
  */ 
@@ -2489,7 +2523,7 @@
   AddTestCase (new NormalCachingTestCase);
 }
 
-static RandomVariableSuite randomVariableSuite;
+static RandomVariableSuite randomVariableSuite;  //!< Static variable for test initialization
 
 }  // namespace RandomVariable
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/rng-test-suite.cc ns-3.36/src/core/test/rng-test-suite.cc
--- ns-3.35/src/core/test/rng-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/rng-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -28,6 +28,26 @@
 
 using namespace ns3;
 
+/**
+ * \file
+ * \ingroup rng-tests
+ * Random number generators tests.
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup rng-tests Random number generators tests
+ */
+
+/**
+ * \ingroup rng-tests
+ * 
+ * Fill an array with increasing values, in the [start, end] range.
+ * \param array The array to fill.
+ * \param n The size of the array.
+ * \param start The start value.
+ * \param end The end value.
+ */
 void
 FillHistoRangeUniformly (double *array, uint32_t n, double start, double end)
 {
@@ -41,19 +61,29 @@
     }
 }
 
-// ===========================================================================
-// Test case for uniform distribution random number generator
-// ===========================================================================
+/**
+ * \ingroup core-tests
+ * 
+ * Test case for uniform distribution random number generator.
+ */
 class RngUniformTestCase : public TestCase
 {
 public:
+  /// Number of runs.
   static const uint32_t N_RUNS = 5;
+  /// Number of bins.
   static const uint32_t N_BINS = 50;
+  /// Number of measurements.
   static const uint32_t N_MEASUREMENTS = 1000000;
 
   RngUniformTestCase ();
   virtual ~RngUniformTestCase ();
 
+  /**
+   * Run a chi-squared test on the results of the random number generator.
+   * \param u The random number generaor.
+   * \return the chi-squared test result.
+   */
   double ChiSquaredTest (Ptr<UniformRandomVariable> u);
 
 private:
@@ -122,19 +152,29 @@
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 }
 
-// ===========================================================================
-// Test case for normal distribution random number generator
-// ===========================================================================
+/**
+ * \ingroup rng-tests
+ * 
+ * Test case for normal distribution random number generator.
+ */
 class RngNormalTestCase : public TestCase
 {
 public:
+  /// Number of runs.
   static const uint32_t N_RUNS = 5;
+  /// Number of bins.
   static const uint32_t N_BINS = 50;
+  /// Number of measurements.
   static const uint32_t N_MEASUREMENTS = 1000000;
 
   RngNormalTestCase ();
   virtual ~RngNormalTestCase ();
 
+  /**
+   * Run a chi-squared test on the results of the random number generator.
+   * \param n The random number generaor.
+   * \return the chi-squared test result.
+   */
   double ChiSquaredTest (Ptr<NormalRandomVariable> n);
 
 private:
@@ -217,19 +257,29 @@
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 }
 
-// ===========================================================================
-// Test case for exponential distribution random number generator
-// ===========================================================================
+/**
+ * \ingroup rng-tests
+ * 
+ * Test case for exponential distribution random number generator.
+ */
 class RngExponentialTestCase : public TestCase
 {
 public:
+  /// Number of runs.
   static const uint32_t N_RUNS = 5;
+  /// Number of bins.
   static const uint32_t N_BINS = 50;
+  /// Number of measurements.
   static const uint32_t N_MEASUREMENTS = 1000000;
 
   RngExponentialTestCase ();
   virtual ~RngExponentialTestCase ();
 
+  /**
+   * Run a chi-squared test on the results of the random number generator.
+   * \param n The random number generaor.
+   * \return the chi-squared test result.
+   */
   double ChiSquaredTest (Ptr<ExponentialRandomVariable> n);
 
 private:
@@ -311,19 +361,29 @@
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 }
 
-// ===========================================================================
-// Test case for pareto distribution random number generator
-// ===========================================================================
+/**
+ * \ingroup rng-tests
+ * 
+ * Test case for pareto distribution random number generator.
+ */
 class RngParetoTestCase : public TestCase
 {
 public:
+  /// Number of runs.
   static const uint32_t N_RUNS = 5;
+  /// Number of bins.
   static const uint32_t N_BINS = 50;
+  /// Number of measurements.
   static const uint32_t N_MEASUREMENTS = 1000000;
 
   RngParetoTestCase ();
   virtual ~RngParetoTestCase ();
 
+  /**
+   * Run a chi-squared test on the results of the random number generator.
+   * \param p The random number generaor.
+   * \return the chi-squared test result.
+   */
   double ChiSquaredTest (Ptr<ParetoRandomVariable> p);
 
 private:
@@ -410,6 +470,11 @@
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 }
 
+/**
+ * \ingroup rng-tests
+ *  
+ * \brief The random number generators Test Suite.
+ */
 class RngTestSuite : public TestSuite
 {
 public:
@@ -425,4 +490,4 @@
   AddTestCase (new RngParetoTestCase, TestCase::QUICK);
 }
 
-static RngTestSuite rngTestSuite;
+static RngTestSuite g_rngTestSuite; //!< Static variable for test initialization
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/simulator-test-suite.cc ns-3.36/src/core/test/simulator-test-suite.cc
--- ns-3.35/src/core/test/simulator-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/simulator-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -27,26 +27,70 @@
 
 using namespace ns3;
 
+/**
+ * \file
+ * \ingroup simulator-tests
+ * Simulator class test suite
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup simulator-tests Simulator class tests
+ */
+
+/**
+ * \ingroup simulator-tests
+ *  
+ * \brief Check that basic event handling is working with different Simulator implementations.
+ */
 class SimulatorEventsTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor.
+   * \param schedulerFactory Scheduler factory.
+   */
   SimulatorEventsTestCase (ObjectFactory schedulerFactory);
   virtual void DoRun (void);
-  void EventA (int a);
-  void EventB (int b);
-  void EventC (int c);
-  void EventD (int d);
+  /**
+   * Test Event.
+   * \param value Event parameter.
+   * @{
+   */
+  void EventA (int value);
+  void EventB (int value);
+  void EventC (int value);
+  void EventD (int value);
+  /** @} */
+
+  /**
+   * Test Event.
+   */
   void Eventfoo0 (void);
+
+  /**
+   * Get the simulator time.
+   * \return The actual time [ms].
+   */
   uint64_t NowUs (void);
-  void destroy (void);
-  bool m_b;
+  /**
+   * Checks that the events has been detroyed.
+   */
+  void Destroy (void);
+  /**
+   * Checks that events are properly handled.
+   * @{
+   */
   bool m_a;
+  bool m_b;
   bool m_c;
   bool m_d;
-  EventId m_idC;
   bool m_destroy;
-  EventId m_destroyId;
-  ObjectFactory m_schedulerFactory;
+  /** @} */
+
+  EventId m_idC;        //!< Event C.
+  EventId m_destroyId;  //!< Event to check event lifetime.
+  ObjectFactory m_schedulerFactory; //!< Scheduler factory.
 };
 
 SimulatorEventsTestCase::SimulatorEventsTestCase (ObjectFactory schedulerFactory)
@@ -62,9 +106,8 @@
 }
 
 void
-SimulatorEventsTestCase::EventA (int a)
+SimulatorEventsTestCase::EventA ([[maybe_unused]] int a)
 {
-  NS_UNUSED (a);
   m_a = false;
 }
 
@@ -84,9 +127,8 @@
 }
 
 void
-SimulatorEventsTestCase::EventC (int c)
+SimulatorEventsTestCase::EventC ([[maybe_unused]] int c)
 {
-  NS_UNUSED (c);
   m_c = false;
 }
 
@@ -108,7 +150,7 @@
 {}
 
 void
-SimulatorEventsTestCase::destroy (void)
+SimulatorEventsTestCase::Destroy (void)
 {
   if (m_destroyId.IsExpired ())
     {
@@ -148,17 +190,17 @@
   NS_TEST_EXPECT_MSG_EQ (anotherId.IsExpired (), true, "Event was removed: it is now expired");
 
   m_destroy = false;
-  m_destroyId = Simulator::ScheduleDestroy (&SimulatorEventsTestCase::destroy, this);
+  m_destroyId = Simulator::ScheduleDestroy (&SimulatorEventsTestCase::Destroy, this);
   NS_TEST_EXPECT_MSG_EQ (!m_destroyId.IsExpired (), true, "Event should not have expired yet");
   m_destroyId.Cancel ();
   NS_TEST_EXPECT_MSG_EQ (m_destroyId.IsExpired (), true, "Event was canceled: should have expired now");
 
-  m_destroyId = Simulator::ScheduleDestroy (&SimulatorEventsTestCase::destroy, this);
+  m_destroyId = Simulator::ScheduleDestroy (&SimulatorEventsTestCase::Destroy, this);
   NS_TEST_EXPECT_MSG_EQ (!m_destroyId.IsExpired (), true, "Event should not have expired yet");
   Simulator::Remove (m_destroyId);
   NS_TEST_EXPECT_MSG_EQ (m_destroyId.IsExpired (), true, "Event was canceled: should have expired now");
 
-  m_destroyId = Simulator::ScheduleDestroy (&SimulatorEventsTestCase::destroy, this);
+  m_destroyId = Simulator::ScheduleDestroy (&SimulatorEventsTestCase::Destroy, this);
   NS_TEST_EXPECT_MSG_EQ (!m_destroyId.IsExpired (), true, "Event should not have expired yet");
 
   Simulator::Run ();
@@ -170,20 +212,36 @@
   NS_TEST_EXPECT_MSG_EQ (m_destroy, true, "Event should have run");
 }
 
+
+/**
+ * \ingroup simulator-tests
+ *  
+ * \brief Check that all templates are instantiated correctly.
+ * 
+ * This is a compilation test, it cannot fail at runtime.
+ */
 class SimulatorTemplateTestCase : public TestCase
 {
 public:
   SimulatorTemplateTestCase ();
-  // only here for testing of Ptr<>
-  void Ref (void) const
-  {}
-  void Unref (void) const
-  {}
+  /**
+   * Ref and Unref - only here for testing of Ptr<>
+   * 
+   * @{
+   */
+  void Ref (void) const {};
+  void Unref (void) const {};
+  /** @} */
 
 private:
   virtual void DoRun (void);
 
   /* *NS_CHECK_STYLE_OFF* */
+  /**
+   * Function used for scheduling.
+   * 
+   * @{
+   */
   void bar0 (void) {}
   void bar1 (int) {}
   void bar2 (int, int) {}
@@ -217,10 +275,16 @@
   void cbaz3c (const int &, const int &, const int &) const {}
   void cbaz4c (const int &, const int &, const int &, const int &) const {}
   void cbaz5c (const int &, const int &, const int &, const int &, const int &) const {}
+  /** @} */
   /* *NS_CHECK_STYLE_ON* */
 
 };
 
+/**
+  * Function used for scheduling.
+  * 
+  * @{
+  */
 static void foo0 (void)
 {}
 static void foo1 (int)
@@ -253,6 +317,7 @@
 {}
 static void cber5 (const int &, const int &, const int &, const int &, const int &)
 {}
+/** @} */
 
 SimulatorTemplateTestCase::SimulatorTemplateTestCase ()
   : TestCase ("Check that all templates are instantiated correctly. This is a compilation test, it cannot fail at runtime.")
@@ -465,6 +530,12 @@
   Simulator::Destroy ();
 }
 
+
+/**
+ * \ingroup simulator-tests
+ *  
+ * \brief The simulator Test Suite.
+ */
 class SimulatorTestSuite : public TestSuite
 {
 public:
@@ -484,4 +555,6 @@
     factory.SetTypeId (PriorityQueueScheduler::GetTypeId ());
     AddTestCase (new SimulatorEventsTestCase (factory), TestCase::QUICK);
   }
-} g_simulatorTestSuite;
+};
+
+static SimulatorTestSuite g_simulatorTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/threaded-test-suite.cc ns-3.36/src/core/test/threaded-test-suite.cc
--- ns-3.35/src/core/test/threaded-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/threaded-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -35,30 +35,81 @@
 
 using namespace ns3;
 
+/// Maximum number of threads.
 #define MAXTHREADS 64
 
+/**
+ * \file
+ * \ingroup threaded-tests
+ * Threaded events test suite
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup threaded-tests Threaded events tests
+ */
+
+/**
+ * \ingroup threaded-tests
+ *  
+ * \brief Check threaded event handling with various thread number, schedulers, and  simulator types.
+ */
 class ThreadedSimulatorEventsTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor.
+   * 
+   * \param schedulerFactory The scheduler factory.
+   * \param simulatorType The simulator type.
+   * \param threads The number of threads.
+   */
   ThreadedSimulatorEventsTestCase (ObjectFactory schedulerFactory, const std::string &simulatorType, unsigned int threads);
+  /**
+   * Event A
+   * \param a The Event parameter.
+   */
   void EventA (int a);
+  /**
+   * Event B
+   * \param b The Event parameter.
+   */
   void EventB (int b);
+  /**
+   * Event C
+   * \param c The Event parameter.
+   */
   void EventC (int c);
+  /**
+   * Event D
+   * \param d The Event parameter.
+   */
   void EventD (int d);
+  /**
+   * No-op function, records the thread that called it. 
+   * \param threadno The thread number.
+   */
   void DoNothing (unsigned int threadno);
+  /**
+   * Schedule a thread.
+   * \param context The context.
+   */
   static void SchedulingThread (std::pair<ThreadedSimulatorEventsTestCase *, unsigned int> context);
+  /**
+   * End the thread execution.
+   */
   void End (void);
-  uint64_t m_b;
-  uint64_t m_a;
-  uint64_t m_c;
-  uint64_t m_d;
-  unsigned int m_threads;
-  bool m_threadWaiting[MAXTHREADS];
-  bool m_stop;
-  ObjectFactory m_schedulerFactory;
-  std::string m_simulatorType;
-  std::string m_error;
-  std::list<Ptr<SystemThread> > m_threadlist;
+  uint64_t m_a; //!< The value incremented when EventA is called.
+  uint64_t m_b; //!< The value incremented when EventB is called.
+  uint64_t m_c; //!< The value incremented when EventC is called.
+  uint64_t m_d; //!< The value incremented when EventD is called.
+  unsigned int m_threads; //!< The number of threads.
+  bool m_threadWaiting[MAXTHREADS]; //!< Threads waiting to be scheduled.
+  bool m_stop;  //!< Stop variable.
+  ObjectFactory m_schedulerFactory; //!< Scheduler factory.
+  std::string m_simulatorType;      //!< Simulator type.
+  std::string m_error;              //!< Error condition.
+  std::list<Ptr<SystemThread> > m_threadlist; //!< Thread list.
 
 private:
   virtual void DoSetup (void);
@@ -225,6 +276,11 @@
   NS_TEST_EXPECT_MSG_EQ (m_a, m_d, "Bad scheduling");
 }
 
+/**
+ * \ingroup threaded-tests
+ *  
+ * \brief The threaded simulator Test Suite.
+ */
 class ThreadedSimulatorTestSuite : public TestSuite
 {
 public:
@@ -263,4 +319,7 @@
           }
       }
   }
-} g_threadedSimulatorTestSuite;
+};
+
+/// Static variable for test initialization.
+static ThreadedSimulatorTestSuite g_threadedSimulatorTestSuite; 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/timer-test-suite.cc ns-3.36/src/core/test/timer-test-suite.cc
--- ns-3.35/src/core/test/timer-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/timer-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -22,15 +22,33 @@
 #include "ns3/simulator.h"
 #include "ns3/nstime.h"
 
+/**
+ * \file
+ * \ingroup timer-tests
+ * Timer test suite
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup timer-tests Timer tests
+ */
+
 namespace {
 
 /* *NS_CHECK_STYLE_OFF* */
+/// Function with one int parameter.
 void bari (int) {}
+/// Function with two int parameters.
 void bar2i (int, int) {}
+/// Function with three int parameters.
 void bar3i (int, int, int) {}
+/// Function with four int parameters.
 void bar4i (int, int, int, int) {}
+/// Function with five int parameters.
 void bar5i (int, int, int, int, int) {}
+/// Function with one const int reference parameter.
 void barcir (const int &) {}
+/// Function with one int reference parameter.
 void barir (int &) {}
 /* *NS_CHECK_STYLE_ON* */
 
@@ -38,6 +56,11 @@
 
 using namespace ns3;
 
+/**
+ * \ingroup timer-tests
+ *  
+ * \brief Check correct state transitions.
+ */
 class TimerStateTestCase : public TestCase
 {
 public:
@@ -82,6 +105,11 @@
   NS_TEST_ASSERT_MSG_EQ (timer.GetState (), Timer::EXPIRED, "");
 }
 
+/**
+ * \ingroup timer-tests
+ *  
+ * \brief Check that Timer template magic is working.
+ */
 class TimerTemplateTestCase : public TestCase
 {
 public:
@@ -90,15 +118,25 @@
   virtual void DoTeardown (void);
 
   /* *NS_CHECK_STYLE_OFF* */
+  /// Member function with one int parameter.
   void bazi (int) {}
+  /// Member function with two int parameters.
   void baz2i (int, int) {}
+  /// Member function with three int parameters.
   void baz3i (int, int, int) {}
+  /// Member function with four int parameters.
   void baz4i (int, int, int, int) {}
+  /// Member function with five int parameters.
   void baz5i (int, int, int, int, int) {}
+  /// Member function with six int parameters.
   void baz6i (int, int, int, int, int, int) {}
+  /// Member function with one const int reference parameter.
   void bazcir (const int&) {}
+  /// Member function with one int reference parameter.
   void bazir (int&) {}
+  /// Member function with one int pointer parameter.
   void bazip (int *) {}
+  /// Member function with one const int pointer parameter.
   void bazcip (const int *) {}
   /* *NS_CHECK_STYLE_ON* */
 };
@@ -179,7 +217,12 @@
   Simulator::Destroy ();
 }
 
-static class TimerTestSuite : public TestSuite
+/**
+ * \ingroup timer-tests
+ *  
+ * \brief The timer Test Suite.
+ */
+class TimerTestSuite : public TestSuite
 {
 public:
   TimerTestSuite ()
@@ -188,4 +231,6 @@
     AddTestCase (new TimerStateTestCase (), TestCase::QUICK);
     AddTestCase (new TimerTemplateTestCase (), TestCase::QUICK);
   }
-} g_timerTestSuite;
+};
+
+static TimerTestSuite g_timerTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/traced-callback-test-suite.cc ns-3.36/src/core/test/traced-callback-test-suite.cc
--- ns-3.35/src/core/test/traced-callback-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/traced-callback-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -18,10 +18,25 @@
 
 #include "ns3/test.h"
 #include "ns3/traced-callback.h"
-#include "ns3/unused.h"
 
 using namespace ns3;
 
+/**
+ * \file
+ * \ingroup tracedcallback-tests
+ * TracedCallback test suite
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup tracedcallback-tests TracedCallback class tests
+ */
+
+/**
+ * \ingroup tracedcallback-tests
+ * 
+ * TracedCallback Test case, check basic TracedCallback operation.
+ */
 class BasicTracedCallbackTestCase : public TestCase
 {
 public:
@@ -32,11 +47,21 @@
 private:
   virtual void DoRun (void);
 
+  /**
+   * First callback.
+   * \param a First parameter.
+   * \param b Second parameter.
+   */
   void CbOne (uint8_t a, double b);
+  /**
+   * Second callback.
+   * \param a First parameter.
+   * \param b Second parameter.
+   */
   void CbTwo (uint8_t a, double b);
 
-  bool m_one;
-  bool m_two;
+  bool m_one; //!< Variable set by the first callback.
+  bool m_two; //!< Variable set by the second callback.
 };
 
 BasicTracedCallbackTestCase::BasicTracedCallbackTestCase ()
@@ -44,18 +69,14 @@
 {}
 
 void
-BasicTracedCallbackTestCase::CbOne (uint8_t a, double b)
+BasicTracedCallbackTestCase::CbOne ([[maybe_unused]] uint8_t a, [[maybe_unused]] double b)
 {
-  NS_UNUSED (a);
-  NS_UNUSED (b);
   m_one = true;
 }
 
 void
-BasicTracedCallbackTestCase::CbTwo (uint8_t a, double b)
+BasicTracedCallbackTestCase::CbTwo ([[maybe_unused]] uint8_t a, [[maybe_unused]] double b)
 {
-  NS_UNUSED (a);
-  NS_UNUSED (b);
   m_two = true;
 }
 
@@ -113,6 +134,11 @@
   NS_TEST_ASSERT_MSG_EQ (m_two, true, "Callback CbTwo not called");
 }
 
+/**
+ * \ingroup tracedcallback-tests
+ *  
+ * \brief The traced callback Test Suite.
+ */
 class TracedCallbackTestSuite : public TestSuite
 {
 public:
@@ -125,4 +151,4 @@
   AddTestCase (new BasicTracedCallbackTestCase, TestCase::QUICK);
 }
 
-static TracedCallbackTestSuite tracedCallbackTestSuite;
+static TracedCallbackTestSuite g_tracedCallbackTestSuite; //!< Static variable for test initialization
